unit Cd;

interface

uses
	SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
	Forms, Dialogs, StdCtrls, ExtCtrls, MPlayer, Buttons,MMsystem, Cdedit, Ledcntrl,
  volume, IniFiles, ComCtrls ;

type
	TCDForm = class(TForm)
		CDPanel: TMediaPlayer;
		Ticker: TTimer;
		TrackList: TComboBox;
		TimerMethod1: TSpeedButton;
		TimerMethod2: TSpeedButton;
		Label1: TLabel;
		TrackOnce: TSpeedButton;
		TrackRepeat: TSpeedButton;
		TimerMethod3: TSpeedButton;
		TimerMethod4: TSpeedButton;
		CDOnce: TSpeedButton;
		CDRepeat: TSpeedButton;
		Label2: TLabel;
		PowerButton: TSpeedButton;
    Bevel2: TBevel;
	Bevel3: TBevel;
	Bevel4: TBevel;
    Bevel5: TBevel;
	Button1: TButton;
	Bevel6: TBevel;
	 Shape1: TShape;
	TitleOfCD: TLabel;
	Artist: TLabel;
	TimeDisp: TLEDDisp;
	Track: TLEDDisp;
	Bevel7: TBevel;
	BackDisp: TShape;
	Bevel1: TBevel;
	OnTopButton: TSpeedButton;
	MMPlay: TSpeedButton;
	MMPause: TSpeedButton;
    MMStop: TSpeedButton;
    MMForward: TSpeedButton;
    MMRewind: TSpeedButton;
    MMNext: TSpeedButton;
    MMPrev: TSpeedButton;
    MMEject: TSpeedButton;
	MoveTimer: TTimer;
    Volume: TTrackBar;
	procedure TickerTimer(Sender: TObject);
	procedure FormCreate(Sender: TObject);
	procedure TrackListClick(Sender: TObject);
	procedure TrackOnceClick(Sender: TObject);
	procedure TrackRepeatClick(Sender: TObject);
	procedure CDOnceClick(Sender: TObject);
	procedure CDRepeatClick(Sender: TObject);
	procedure TimerMethod1Click(Sender: TObject);
	procedure TimerMethod2Click(Sender: TObject);
	procedure TimerMethod3Click(Sender: TObject);
	procedure TimerMethod4Click(Sender: TObject);
	procedure Button1Click(Sender: TObject);
	procedure PowerButtonClick(Sender: TObject);
	procedure FormClose(Sender: TObject; var Action: TCloseAction);
	procedure FormDblClick(Sender: TObject);
	procedure OnTopButtonClick(Sender: TObject);
	procedure VolumeChange(Sender: TObject);
	procedure FormActivate(Sender: TObject);
    procedure MMPlayClick(Sender: TObject);
	procedure MMPauseClick(Sender: TObject);
	procedure MMStopClick(Sender: TObject);
	procedure MMForwardClick(Sender: TObject);
	procedure MMRewindClick(Sender: TObject);
	procedure MMNextClick(Sender: TObject);
	procedure MMPrevClick(Sender: TObject);
	procedure MMEjectClick(Sender: TObject);
    procedure MMForwardMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MMForwardMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MoveTimerTimer(Sender: TObject);
    procedure MMRewindMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MMRewindMouseUp(Sender: TObject; Button: TMouseButton;
	  Shift: TShiftState; X, Y: Integer);
	private
		procedure WMSizing(var mess: TMessage); message WM_Sizing;
	{ Private declarations }
	public
	{ Public declarations }
	RealCmdShow: word;
end;

const
	MAXTRACKS=99;
const
	CDDEVICE=2;

const
  AllowedInstances = 0;

type TrackDetail=record
	TrackTitle: string[80];
	TrackStart: longint;
	TrackLength: longint
end;

type CDDetail=record
	CDTitle: string[80];
	Artist: string[80];
	TotalTracks: integer;
	CDLength: longint;
	TrackDetail: array[1..MAXTRACKS] of TrackDetail
end;

type
	CDStates=(cdOffline,cdPlaying,cdStopped,cdNotReady,cdPaused);
	TimerModes=(tmTrackGone,tmTrackLeft,tmCDGone,tmCDLeft);
	PlayModes=(plTrackOnce,plTrackRepeat,plCDOnce,plCDRepeat);

var
	CDForm: TCDForm;
	PlayerStatus: CDStates;
	LastPlayerStatus: CDStates;
	CurrentTrack,LoopTrack: integer;
	TrackPosition,CDPosition: longint;
	CurRemaining,CDRemaining: longint;
	TimerMode: TimerModes;
	PlayMode: PlayModes;
	EndPosition: longint;
	CurrentCD: CDDetail;
	Disptype: integer;
	OnTop: Integer;
	CDKey: string;
	GlobalCD: CDDetail;
	MyAppName, MyClassName: array[0..255] of Char;
	NumFound: Integer;
	LastFound, MyPopup: HWND;
	downcnt: integer;
	stepgap: integer;

procedure SetButtons(CDMode: CDStates);
procedure SetTimerTrack(tim:integer;tck: integer);
procedure SetupNewCD;
procedure TurnOnLEDs;
procedure TurnOffLEDs;
procedure EnablePlayer;
procedure DisablePlayer;
procedure GotoTrack(tracknum: integer);
procedure GotoPosition(pos: longint);
procedure GetPositions;
procedure PositionDisplay;
function GetPlayerStatus: CDStates;
procedure CDOfflineTimer;
procedure CDPlayingTimer;
procedure CDNotReadyTimer;
procedure CDStoppedTimer;
procedure CDPausedTimer;
function MilliToTime(t: LongInt): string;
procedure FindCD(key: string;var ACD: CDDetail);
procedure MakeCDKey(var ACD: CDDetail;var key: string);
procedure EditCD(var EdCD: CDDetail;key: string);
function ZeroFill(size: integer;s: string): string;
procedure WriteCD(key: string;var ACD: CDDetail);
procedure CDDetails(var ACD: CDDetail;s: integer);
function GetEndPosition(tracknum: integer): longint;
procedure SetTimer(t: CDStates);
procedure UpdateTracklist(l: integer);
procedure SetVolumeScroller;
procedure SetFormCaption(s: string);
procedure preparefornewCD;

implementation
{$R *.DFM}

procedure TCDForm.WMSizing(var mess: TMessage);
type
	rp=^TRect;
var
	r:rp;
	w,h: integer;
begin
	r:=rp(mess.LParam);
	h:=r.bottom-r.top;
	w:=236;
	case h of
		0..73: begin h:=73; w:=140; end;
		74..100: h:=100;
		101..137: h:=137;
		138..167: h:=167;
	else
		h:=208;
		w:=264;
	end;
	// Left and right sizing not to do anything
	if mess.WParam in [WMSZ_TOP,WMSZ_TOPLEFT,WMSZ_TOPRIGHT] then
		r.top:=r.bottom-h;
	if mess.WParam in [WMSZ_BOTTOM,WMSZ_BOTTOMLEFT,WMSZ_BOTTOMRIGHT] then
		r.bottom:=r.top+h;
	if mess.WParam in [{WMSZ_LEFT,}WMSZ_BOTTOMLEFT,WMSZ_TOPLEFT] then
		r.left:=r.right-w;
	if mess.WParam in [{WMSZ_RIGHT,}WMSZ_BOTTOMRIGHT,WMSZ_BOTTOMLEFT,
		WMSZ_TOP,WMSZ_BOTTOM] then
		r.right:=r.left+w;
	if mess.WParam in [WMSZ_RIGHT] then
		r.right:=r.left+w;
	if mess.WParam in [WMSZ_LEFT] then
		r.left:=r.right-w;
	mess.Result:=1;
end;

{ Enable/Disable CDPlayer Buttons }
procedure SetButtons(CDMode: CDStates);
var
	n,m: TButtonSet;
begin
	n:=CDForm.CDPanel.EnabledButtons;
 {	case CDMode of
		CDOffline: m:=[btEject];
		CDPlaying: m:=[btPause,btStop,btNext,btPrev,btStep,btBack,btEject];
		CDStopped: m:=[btPlay,btEject];
		CDNotReady:m:=[btEject];
		CDPaused: m:=[btPause,btStop,btEject];
	end; }
	with CDForm do
		case CDMode of
			CDOffLine, CDNotReady:	begin
				MMPlay.Enabled:=False;	MMPause.Enabled:=False;
				MMStop.Enabled:=False;	MMForward.Enabled:=False;
				MMRewind.Enabled:=False;	MMNext.Enabled:=False;
				MMPrev.Enabled:=False;	MMEject.Enabled:=True;
			end;
			CDPlaying: begin
				MMPlay.Enabled:=True; MMPlay.Down:=True;
				MMPause.Enabled:=True;
				MMStop.Enabled:=True; 	MMForward.Enabled:=True;
				MMRewind.Enabled:=True;	MMNext.Enabled:=True;
				MMPrev.Enabled:=True;  	MMEject.Enabled:=True;
			end;
			CDStopped: begin
				MMPlay.Enabled:=True;	MMPause.Enabled:=False;
				MMStop.Enabled:=False; 	MMForward.Enabled:=False;
				MMRewind.Enabled:=False;	MMNext.Enabled:=False;
				MMPrev.Enabled:=False;  	MMEject.Enabled:=True;
			end;
			CDPaused: begin
				MMPlay.Enabled:=True;	MMPause.Enabled:=True;
				MMPause.Down:=True;
				MMStop.Enabled:=True; 	MMForward.Enabled:=True;
				MMRewind.Enabled:=True;	MMNext.Enabled:=False;
				MMPrev.Enabled:=False;  	MMEject.Enabled:=True;
			end;
		end;
{ Only alter the buttons if the new setting is different -
  this stops flickering }
	if n<>m then CDForm.CDPanel.EnabledButtons:=m;
end;

procedure SetTimerTrack(tim:integer;tck: integer);
var
	minutes,seconds: integer;
	m,s,t: string[2];
begin
	t:=zerofill(2,inttostr(tck));
	CDForm.Track.Enabled:=True;
	CDForm.Track.Display:=t;

	minutes:=tim div 60;
	seconds:=tim -(minutes*60);
	m:=zerofill(2,inttostr(minutes));
	s:=zerofill(2,inttostr(seconds));
	CDForm.TimeDisp.Display:=m + '.' + s ;
{	Application.Title:='CD Player:'+t +
		' ' + m+ '.' + s; }
{	Application.Title:='CD Player:'+t +
		' ' + m+ '.' + s + ' ' + Copy(CDForm.TrackList.Text, Pos(')',
		CDForm.TrackList.Text) + 2, 100) ; // Greg Lief 1/2/97 }
	Application.Title:='CD Player:'+t+' ' + m+ '.' + s+' '+
		CurrentCD.TrackDetail[CurrentTrack].TrackTitle;  // Slightly better way
end;

procedure SetupNewCD;
var
	lp: integer;
begin
{ Get the total number of tracks for the new CD, And update the display }
	CDForm.CDPanel.Timeformat:=tfMilliseconds;
	CurrentCD.TotalTracks:=CDForm.CDPanel.Tracks;
{ Get the Total length of the CD}
	CurrentCD.CDLength:=CDForm.CDPanel.Length;
{ Clear the Track List, then store track information }
	for lp:=1 to CurrentCD.TotalTracks do
	begin
		CurrentCD.TrackDetail[lp].TrackStart:=CDForm.CDPanel.TrackPosition[lp];
		CurrentCD.TrackDetail[lp].TrackLength:=CDForm.CDPanel.TrackLength[lp];
		CurrentCD.TrackDetail[lp].TrackTitle:='';
	end;
{ Get the current CDs Key }
	MakeCDKey(CurrentCD,CDKey);
	FindCD(CDKey,CurrentCD);
	CDDetails(CurrentCD,1);
// Update the display
	SetTimerTrack(CurrentCD.CDLength Div 1000,CurrentCD.TotalTracks);
{ Initialise the TrackList TrackName, This will change if the
  CD is currently playing }
	CurrentTrack:=1;
	UpdateTrackList(1);
end;

{ Set all the LEDs to On 0's }
procedure TurnOnLEDs;
begin
	CDForm.Track.Enabled:=True;
	CDForm.TimeDisp.Enabled:=True;
end;

{  Set all the LEDs to Off 0's }
procedure TurnOffLEDs;
begin
	CDForm.Track.Enabled:=False;
	CDForm.TimeDisp.Enabled:=False;
end;

{ Activate all controls etc.. }
procedure EnablePlayer;
begin
	TurnOnLEDs;
	CDForm.CDPanel.Enabled:=True;
	CDForm.Tracklist.Enabled:=True;
	CDForm.Button1.Enabled:=True
end;

procedure SetDisp(d: integer);
begin
	with CDForm do
	begin
		Track.DisplayType:=d;
		TimeDisp.DisplayType:=d;
		if d=0 then
		begin
		// Green on black displays
			BackDisp.Brush.Color:=clBlack;
			Shape1.Pen.Color:=clBlack;
			Shape1.Brush.Color:=clBlack;
			TitleOfCD.Color:=clBlack;
			TitleOfCD.Font.Color:=clLime;
			Artist.Color:=clBlack;
			Artist.Font.Color:=clLime;
			TrackList.Color:=clBlack;
			TrackList.Font.Color:=clLime;
		end else
		begin
		// Black on silver displays (LCD ish)
			BackDisp.Brush.Color:=clSilver;
			Shape1.Pen.Color:=clSilver;
			Shape1.Brush.Color:=clSilver;
			TitleOfCD.Color:=clSilver;
			TitleOfCD.Font.Color:=clBlack;
			Artist.Color:=clSilver;
			Artist.Font.Color:=clBlack;
			TrackList.Color:=clSilver;
			TrackList.Font.Color:=clBlack;
		end;
	end;
end;

{ Deactivate all controls etc.. }
procedure DisablePlayer;
begin
	TurnOffLeds;
	Setbuttons(CDOffline);
   //	CDForm.CDPanel.Enabled:=False;
	CDDetails(CurrentCD,0);
	CDForm.Tracklist.Enabled:=False;
	CDForm.Button1.Enabled:=False;
	SetFormCaption('');
	CDKey:='';
end;

{ Goto a specified Track Number }
procedure GotoTrack(tracknum: integer);
begin
	if (tracknum<=CurrentCD.TotalTracks) and (tracknum>0) then
		GotoPosition(CurrentCD.TrackDetail[tracknum].TrackStart);
end;

{ Goto a specified position }
procedure GotoPosition(pos: longint);
begin
	if CDForm.CDPanel.Mode=mpPlaying then
	begin
		CDForm.CDPanel.Pause;
		CDForm.CDPanel.Position:=pos;
		CDForm.CDPanel.Resume;
	end else
		CDForm.CDPanel.Position:=pos;
end;

{ Get all the current positions of the CD Player }
procedure GetPositions;
var
	lp: integer;
begin
{ Get the Current Position }
	CDPosition:=CDForm.CDPanel.Position;
{ Get the current Track - I might lose this as EndPosition
	allows me to determine the Current Track }
	for lp:=1 to CurrentCD.TotalTracks do
		if CDPosition>=CurrentCD.TrackDetail[lp].TrackStart then
			CurrentTrack:=lp ;
{ Get Position within track }
	TrackPosition:=CDPosition -
		CurrentCD.TrackDetail[CurrentTrack].TrackStart;
{ Time Left on CD }
	CDRemaining:=CurrentCD.CDLength - CDPosition;
{ Time Left on Track }
	CurRemaining:=CurrentCD.TrackDetail[CurrentTrack].TrackLength -
		TrackPosition;
end;

{ Update the timer display with the currently selected time }
procedure PositionDisplay;
var
	TheTime: longint;
begin
{ Depending on the timer mode currently selected
	Get the time to display }
	case TimerMode of
		tmTrackLeft: TheTime:=CurRemaining;
		tmCDGone: TheTime:=CDPosition;
		tmCDLeft: TheTime:=CDRemaining;
	else { and tmTrackGone: }
		TheTime:=TrackPosition;
	end;
	SetTimerTrack(TheTime Div 1000,CurrentTrack);
end;

{ Get the status of the CD Player, or leave it unchanged if unknown
	mpNotReady,mpStopped,mpPlaying,mpRecording,
	mpSeeking,mpPaused,mpOpen }
function GetPlayerStatus: CDStates;
begin
	case CDForm.CDPanel.mode of
		mpStopped:
			if PlayerStatus=CDPaused then
				GetPlayerStatus:=CDPaused
			else
				GetPlayerStatus:=CDStopped;
		mpPlaying: GetPlayerStatus:=CDPlaying ;
		mpPaused: GetPlayerStatus:=CDPaused ;
		mpSeeking,mpOpen,
		mpNotReady,mpRecording: GetPlayerStatus:=CDNotReady;
	else
{ The only time this should occur is if the player is not opened
	and a random(ish) result is returned }
		GetPlayerStatus:=PlayerStatus;
	end;
end;

{ To prevent the disk drive whirring that happens when the CD
	is attempted to be open and there is no CD in, the timer
		event is slown down unless the CD is playing }
procedure SetTimer(t: CDStates);
var
	tm: integer;
begin
	case t of
		cdPlaying: tm:=200;
	else
		tm:=1000;
	end;
	if CDForm.Ticker.interval<>tm then
		CDForm.Ticker.interval:=tm;
end;

{ Return the end position for a particular track }
function GetEndPosition(tracknum: integer): longint;
var
	p: longint;
begin
	p:=CurrentCD.TrackDetail[tracknum].TrackStart+
		CurrentCD.TrackDetail[tracknum].TrackLength;
	if tracknum=CurrentCD.TotalTracks then
		p:=p-300;
	GetEndPosition:=p;
end;

{ When the CD is Offline - i.e. Not yet opened }
procedure CDOfflineTimer;
begin
	try
		CDForm.CDPanel.open;
		PlayerStatus:=GetPlayerStatus;
		case PlayerStatus of
			CDStopped,CDPlaying,CDPaused: preparefornewCD;
		end;
		setbuttons(Playerstatus);
		if ParamStr(1)='/play' then CDForm.CDPanel.Play;
	except
{ Do nothing if exception occurred }
	end;
end;

{ Return the next track to play
	0 means stop - no next track }
function GetNextTrack(ThisTrack:integer): integer;
begin
	case PlayMode of
		plTrackOnce: GetNextTrack:=0;
		plTrackRepeat: GetNextTrack:=ThisTrack;
		plCDRepeat:
			if ThisTrack=CurrentCD.TotalTracks then
				GetNextTrack:=1
			else
				GetNextTrack:=ThisTrack+1;
	else { and plCDOnce: }
		if ThisTrack=CurrentCD.TotalTracks then
			GetNextTrack:=0
		else
			GetNextTrack:=ThisTrack+1;
	end;
end;

{ When the CD is Playing }
procedure CDPlayingTimer;
var
	LastTrackPlayed: integer;
	NextTrack: integer;
begin
{ Get Current Positions }
	LastTrackPlayed:=CurrentTrack;
	GetPositions;
{ If the CD was already playing then this code will be hit }
	if EndPosition=0 then
	begin
		EndPosition:=GetEndPosition(CurrentTrack);
		UpdateTracklist(CurrentTrack);
	end;

{ If at or past end position then handle this }
	if CDPosition>=EndPosition then
	begin
		NextTrack:=GetNextTrack(LastTrackPlayed);
		if NextTrack=0 then CDForm.CDPanel.Stop
		else begin
		{ If next track to play is next track on disk then we can leave
		the player to carry on uninterrupted
		This bit of code will easily allow random track selection etc..
		in the GetNextTrack routine - nothing else need be changed}
			if NextTrack<>LastTrackPlayed+1 then
			begin
				GotoTrack(NextTrack);
				CDForm.CDPanel.Play;
			end;
			UpdateTracklist(NextTrack);
		end;
{ Set EndPosition to be the end of the newly selected track }
		EndPosition:=GetEndPosition(NextTrack);
	end;
{ Status Changes by none button events, i.e. buttons on CD Hardware }
	PlayerStatus:=GetPlayerStatus;
	case PlayerStatus of
		cdPlaying: PositionDisplay; { Update LEDs }
		cdStopped: SetButtons(cdStopped); {End of CD ?}
		cdNotReady: DisablePlayer; {Ejected etc..}
	end;
end;

{Prepare for a new CD}
procedure preparefornewCD;
var
	path: string;
begin
	path:=CDForm.CDPanel.FileName+'\Track01.cda';
	if FileExists(path) then
	begin
		SetUpNewCD;
		EnablePlayer;
		SetButtons(PlayerStatus);
	end else PlayerStatus:=cdNotReady;
end;

{ When the CD is not ready - i.e. Tray Open }
procedure CDNotReadyTimer;
begin
{ Nothing to do while Not Ready }
	PlayerStatus:=GetPlayerStatus;
	case PlayerStatus of
	{ The only probable mode change from notready is to stopped,
		but these modes are all served the same anyway }
		cdPlaying,cdStopped,cdPaused: preparefornewCD;
	end;
end;

{ When the CD is Stopped }
procedure CDStoppedTimer;
begin
{ Nothing to do whilst stopped }
	PlayerStatus:=GetPlayerStatus;
	case PlayerStatus of
		cdPlaying: SetButtons(PlayerStatus); { Stopped - Playing }
		cdNotReady: DisablePlayer; {Ejected etc..}
	end;
{ All other modes will be dealt with by their own timer routine }
end;

{ When the CD is Paused }
procedure CDPausedTimer;
begin
{ Nothing to do whilst paused }
	PlayerStatus:=GetPlayerStatus;
	case PlayerStatus of
		cdStopped: SetButtons(PlayerStatus); { Stopped by panel ? }
	   cdPlaying: SetButtons(PlayerStatus); { Paused -> Playing }
		cdNotReady: DisablePlayer; {Ejected etc..}
	end;
{ All other modes will be dealt with by their own timer routine }
end;

{ CDStates=(CDOffline,CDPlaying,CDStopped,CDNotReady,CDPaused); }
procedure TCDForm.TickerTimer(Sender: TObject);
begin
	case PlayerStatus of
		cdOffLine: CDOfflineTimer;
		cdPlaying: CDPlayingTimer;
		cdNotReady: CDNotReadyTimer;
		cdStopped: CDStoppedTimer;
		cdPaused: CDPausedTimer;
	end;
	SetTimer(PlayerStatus);
	SetVolumeScroller;
end;

procedure SetVolumeScroller;
var
	readvol: Integer;
begin
	try
		auxGetVolume(CDDEVICE,@ReadVol);
		CDForm.Volume.Position:=255-hi(readvol);
	except
	end;
end;

procedure TCDForm.VolumeChange(Sender: TObject);
var
	v,t: Longint;
begin
	t:=255-Volume.Position;
	v:=((t shl 8) or (t shl 24));
	auxsetvolume(CDDEVICE,v);
end;

// Enum Windows Routine
function LookAtAllWindows(Handle: HWND; Temp: LongInt): BOOL; stdcall;
var
  WindowName, ClassName: Array[0..255] of Char;
begin
  // Go get the windows class name
	if GetClassName(Handle, ClassName, SizeOf(ClassName)) > 0 then
	// Is the window class the same ?
		if StrComp(ClassName, MyClassName) = 0 then
		// Get its window caption
			if GetWindowText(Handle, WindowName, SizeOf(WindowName)) > 0 then
			// Does this have the same window title ?
				if StrLComp(WindowName, MyAppName,StrLen(MyAppName)) = 0 then
				begin
					inc(NumFound);
					// Are the handles different ?
					if Handle <> Application.Handle then
					// Save it so we can bring it to the top later.
						LastFound := Handle;
				end;
	Result:=True;
end;

{ Set the CD player and Environment for the first time }
procedure TCDForm.FormCreate(Sender: TObject);
var
	drive: string;
	L: Integer;
	SUI: TStartupInfo;
	CDIniFile: TIniFile;
begin

	NumFound := 0; LastFound := 0;
	// First, determine what this application'name is.
	//GetWindowText(Application.Handle, MyAppName, SizeOf(MyAppName));
	MyAppName:='CD Player';
	// Now determine the class name for this application
	GetClassName(Application.Handle, MyClassName, SizeOf(MyClassName));
	// Now count how many others out there are Delphi apps with this title
	EnumWindows(@LookAtAllWindows, 0);
	if NumFound > AllowedInstances then
	// there is another instance running, bring it to the front !
	begin
		MyPopup := GetLastActivePopup(LastFound);
		// Bring it to the top in the Z-Order
		BringWindowToTop(LastFound);
		// Is the window iconized ?
		if IsIconic(MyPopup) then
			// Restore it to its original position
			ShowWindow(MyPopup, SW_RESTORE)
		else
			// Bring it to the front
			SetForegroundWindow(MyPopup);
			// Halt this instance
		Halt;
	end;

	if CmdShow = SW_SHOWDEFAULT then begin
	  GetStartupInfo(SUI);
	  RealCmdShow := SUI.wShowWindow;
	end else
	  RealCmdShow := CmdShow ;

	if RealCmdShow = SW_SHOWMAXIMIZED then
	  WindowState := wsMaximized;

	Application.Title:='CD Player';

	CDIniFile:=TIniFile.Create('Win.Ini');
	if CDIniFile<>Nil then
	try
		with CDIniFile do
		begin
			CDForm.Left:=ReadInteger('CDPlayer','LeftPos',100);
			CDForm.Top:=ReadInteger('CDPlayer','TopPos',100);
			CDForm.Height:=ReadInteger('CDPlayer','Height',221);
			CDForm.Width:=ReadInteger('CDPlayer','Width',236);
			OnTop:=ReadInteger('CDPlayer','OnTop',0);
			DispType:=ReadInteger('CDPlayer','Display',0);
			Free;
		end;
	except
		CDIniFile.Free;
	end;

	if Ontop>0 then
	begin
		OntopButton.Down:=True;
		OnTopButton.Click;
	end;
	SetDisp(Disptype);

	For L := Ord('C') to Ord('Z') do begin
		drive := Chr(L)+':\'+#0;
		if GetDriveType(Pchar(drive)) = DRIVE_CDROM then
		begin
			CDForm.CDPanel.FileName:=Chr(L)+':';
			break;
		end;
	end;

	DisablePlayer; { Deactivate all controls etc.. }
	PlayerStatus:=CDOffline; { CD isn't opened }
	LastPlayerStatus:=CDOffLine;
	TimerMode:=tmTrackGone; { Default mode of Track time }
	PlayMode:=plCDOnce;	{Default mode of play }
end;

procedure TCDForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
	CDIniFile: TIniFile;
begin
		CDIniFile:=TIniFile.Create('Win.ini');
		if CDIniFile<>Nil then
		try
			with CDIniFile do
			begin
				WriteInteger('CDPlayer','TopPos',CDForm.Top);
				WriteInteger('CDPlayer','LeftPos',CDForm.Left);
				WriteInteger('CDPlayer','Height',CDForm.Height);
				WriteInteger('CDPlayer','Width',CDForm.Width);
				WriteInteger('CDPlayer','Display',DispType);
				WriteInteger('CDPlayer','OnTop',OnTop);
				Free;
			end;
		except
			CDIniFile.Free;
		end;
end;

{ Move the currently displayed track }
procedure UpdateTracklist(l: integer);
begin
	if CDForm.TrackList.Itemindex<>l-1 then
	begin
		CDForm.TrackList.ItemIndex:=l-1;
		SetFormCaption(CurrentCD.TrackDetail[CurrentTrack].TrackTitle);
	end;
end;

procedure SetFormCaption(s: string);
begin
		if s<>'' then
			CDForm.Caption:=s
		else
			CDForm.Caption:='Compact Disk Player';
end;

{ Intercept pressing a button on the CD panel and manually
	perform the tasks }
procedure TCDForm.TrackListClick(Sender: TObject);
begin
	if CurrentTrack<>TrackList.ItemIndex+1 then
	begin
		CurrentTrack:=TrackList.ItemIndex+1;
		EndPosition:=GetEndPosition(CurrentTrack);
		GotoTrack(CurrentTrack);
		SetFormCaption(CurrentCD.TrackDetail[CurrentTrack].TrackTitle);
{ If currently playing then carry on playing }
		if PlayerStatus=cdPlaying then
			CDForm.CDpanel.Play
		else
		begin
{ Otherwise move to the track specified and update the display
	so you know it has moved }
		   GotoTrack(CurrentTrack);
			SetTimerTrack(0,CurrentTrack);
		end;
	end;
end;

procedure TCDForm.TrackOnceClick(Sender: TObject);
begin
	if TrackOnce.Down=False	then
		TrackOnce.Down:=True;
	TrackRepeat.Down:=False;
	CDOnce.Down:=False;
	CDRepeat.Down:=False;
	PlayMode:=plTrackOnce;
end;

procedure TCDForm.TrackRepeatClick(Sender: TObject);
begin
	if TrackRepeat.Down=False then
		TrackRepeat.Down:=True;
	TrackOnce.Down:=False;
	CDOnce.Down:=False;
	CDRepeat.Down:=False;
	PlayMode:=plTrackRepeat;
end;

procedure TCDForm.CDOnceClick(Sender: TObject);
begin
	if CDOnce.Down=False then
		CDOnce.Down:=True;
	TrackRepeat.Down:=False;
	TrackOnce.Down:=False;
	CDRepeat.Down:=False;
	PlayMode:=plCDOnce;
end;

procedure TCDForm.CDRepeatClick(Sender: TObject);
begin
	if CDRepeat.Down=False then
		CDRepeat.Down:=True;
	TrackRepeat.Down:=False;
	TrackOnce.Down:=False;
	CDOnce.Down:=False;
	PlayMode:=plCDRepeat;
end;

{ Really crap routine - but hell who cares? }
function ZeroFill(size: integer;s: string): string;
var
	a,b: integer;
	t: string;
begin
	SetLength(t,size);
	for a:=1 to size do
		t[a]:='0';
	b:=size;
	for a:=length(s) downto 1 do
	begin
		t[b]:=s[a];
		dec(b);
	end;
	ZeroFill:=t;
end;

{ Convert the milliseconds time to minutes:seconds string }
Function MilliToTime(t: LongInt): string;
var
	a: integer;
	s: string;
begin
	a:=t div 1000;
	s:=ZeroFill(2,inttostr(a div 60)) +
		':' + ZeroFill(2,inttostr(a mod 60));
	MilliToTime:=s;
end;

procedure TCDForm.TimerMethod1Click(Sender: TObject);
begin
	if TimerMethod1.Down=False	then
		TimerMethod1.Down:=True;
		TimerMethod2.Down:=False;
		TimerMethod3.Down:=False;
		TimerMethod4.Down:=False;
		TimerMode:=tmTrackGone;
end;

procedure TCDForm.TimerMethod2Click(Sender: TObject);
begin
	if TimerMethod2.Down=False	then
		TimerMethod2.Down:=True;
		TimerMethod1.Down:=False;
		TimerMethod3.Down:=False;
		TimerMethod4.Down:=False;
		TimerMode:=tmTrackLeft;
end;

procedure TCDForm.TimerMethod3Click(Sender: TObject);
begin
	if TimerMethod3.Down=False	then
		TimerMethod3.Down:=True;
		TimerMethod2.Down:=False;
		TimerMethod1.Down:=False;
		TimerMethod4.Down:=False;
		TimerMode:=tmCDGone;
end;

procedure TCDForm.TimerMethod4Click(Sender: TObject);
begin
	if TimerMethod4.Down=False	then
		TimerMethod4.Down:=True;
		TimerMethod2.Down:=False;
		TimerMethod3.Down:=False;
		TimerMethod1.Down:=False;
		TimerMode:=tmCDLeft;
end;

procedure TCDForm.Button1Click(Sender: TObject);
var
	key: string;
begin
{ Edit current CD Details }
	key:=CDKey; { Save the current CD Key }
	EditCD(CurrentCD,key);
end;

{ Edit a CDDetail Record }
procedure EditCD(var EdCD: CDDetail;key: string);
begin
	GlobalCD:=EdCD;
	CDEditForm.ShowModal;
	if CDEditForm.modalresult=mrOk then
	begin
		WriteCD(key,GlobalCD);
		if CDKey=Key then
		begin
			EdCD:=GlobalCD;
			CDDetails(EdCD,1);
			UpdateTrackList(CurrentTrack);
		end;
	end;
end;

{ Create a Key to Identify a CD (Hopefully uniquely) }
procedure MakeCDKey(var ACD: CDDetail;var key: string);
var
	s: string[5];
	lp: integer;
	d: integer;
begin
	key:='';
	if ACD.TotalTracks>60 then d:=60
	else d:=ACD.TotalTracks;
	for lp:=1 to d do
	begin
		s:=MilliToTime(ACD.TrackDetail[lp].TrackLength);
		key:=key+s[1]+s[2]+s[4]+s[5];
	end;
end;

{ Write CD }
procedure WriteCD(key: string;var ACD: CDDetail);
var
	CDIniFile: TIniFile;
	TrackNum: integer;
begin
	CDIniFile:=TIniFile.Create('CDDATA.INI');
	CDIniFile.WriteString(key,'Title',ACD.CDTitle);
	CDIniFile.WriteString(key,'Artist',ACD.Artist);
	for TrackNum:=1 to ACD.TotalTracks do
		CDIniFile.WriteString(key,'Track'+inttostr(TrackNum),
			ACD.TrackDetail[TrackNum].TrackTitle);
	CDIniFile.Free;
end;

{ Find CD in CDDATA.INI file }
procedure FindCD(key: string;var ACD: CDDetail);
var
	CDIniFile: TIniFile;
	TrackNum: integer;
begin
	CDIniFile:=TIniFile.Create('CDDATA.INI');
	ACD.CDTitle:=CDIniFile.ReadString(key,'Title','');
	ACD.Artist:=CDIniFile.ReadString(key,'Artist','');
	for TrackNum:=1 to ACD.TotalTracks do
		ACD.TrackDetail[TrackNum].TrackTitle:=CDIniFile.ReadString(key,
			'Track'+inttostr(TrackNum),'');
	CDIniFile.Free;
end;

{ Setup CD Details on Form }
procedure CDDetails(var ACD: CDDetail;s: integer);
var
	lp: integer;
begin
	if s<>0 then
	begin
		if ACD.CDTitle='' then CDForm.TitleOfCd.Caption:='Untitled'
		else CDForm.TitleOfCD.Caption:=ACD.CDTitle;
		if ACD.Artist='' then CDForm.Artist.Caption:=''
		else CDForm.Artist.Caption:=ACD.Artist;
		CDForm.Tracklist.Clear;
		for lp:=1 to ACD.TotalTracks do
			CDForm.TrackList.Items.ADD(inttostr(lp)+
				': (' + MilliToTime(ACD.TrackDetail[lp].TrackLength) +
				') '+ACD.TrackDetail[lp].TrackTitle);
	end else
	begin
		CDForm.TitleOfCD.Caption:='';
		CDForm.Artist.Caption:='';
		CDForm.TrackList.Clear;
		CDform.TrackList.Text:='';
	end;
end;

procedure TCDForm.PowerButtonClick(Sender: TObject);
begin
	CDForm.Close;
end;

procedure TCDForm.FormDblClick(Sender: TObject);
begin
   DispType:=DispType xor 1;
   Setdisp(DispType);
end;

procedure TCDForm.OnTopButtonClick(Sender: TObject);
begin
	if OnTopButton.Down=True then
	begin
		SetWindowPos(Application.handle,hWnd_TopMost,
			0, 0, 0, 0,SWP_NOMOVE+SWP_NOSIZE);
		OnTop:=1;
	end else
	begin
		OnTop:=0;
		SetWindowPos(Application.handle,hWnd_NoTopMost,
			0, 0, 0, 0,SWP_NOMOVE+SWP_NOSIZE);
	end;
end;

procedure TCDForm.FormActivate(Sender: TObject);
begin
	case RealCmdShow of
	  SW_SHOWMINIMIZED,
	  SW_MINIMIZE,
	  SW_SHOWMINNOACTIVE:
		Application.Minimize;
	end;
end;

procedure TCDForm.MMPlayClick(Sender: TObject);
begin
	if PlayerStatus=CDPaused then
	begin
		PlayerStatus:=CDPlaying;
		SetButtons(CDPlaying);
		CDForm.CDPanel.Play;
	end
	else begin
		PlayerStatus:=CDPlaying;
		SetButtons(CDPlaying);
		GotoTrack(CurrentTrack);
		EndPosition:=GetEndPosition(CurrentTrack);
		UpdateTrackList(CurrentTrack);
		CDForm.CDPanel.Play;
	end;
end;

procedure TCDForm.MMPauseClick(Sender: TObject);
begin
	PlayerStatus:=CDPaused;
	SetButtons(CDPaused);
	CDForm.CDPanel.Pause;
end;

procedure TCDForm.MMStopClick(Sender: TObject);
begin
	PlayerStatus:=CDStopped;
	SetButtons(CDStopped);
	CDForm.CDPanel.Stop;
end;

procedure TCDForm.MMForwardClick(Sender: TObject);
begin
	SetButtons(PlayerStatus);
	MMForward.Down:=False;
end;

procedure TCDForm.MMRewindClick(Sender: TObject);
begin
	SetButtons(PlayerStatus);
	MMRewind.Down:=False;
end;

procedure TCDForm.MMNextClick(Sender: TObject);
begin
	if CurrentTrack<CurrentCD.TotalTracks then
	begin
		inc(CurrentTrack);
		UpdateTrackList(CurrentTrack);
		GotoTrack(CurrentTrack);
		EndPosition:=GetEndPosition(CurrentTrack);
		CDForm.CDPanel.Play;
	end;
	SetButtons(CDPlaying);
end;

procedure TCDForm.MMPrevClick(Sender: TObject);
begin
{ If more than 5 seconds into the track then goto beginning
	of the track }
	if TrackPosition>5000 then
	begin
		GotoTrack(CurrentTrack);
		CDForm.CDPanel.Play;
	end {Otherwise go back one track }
	else if CurrentTrack>1 then
	begin
		dec(CurrentTrack);
		UpdateTrackList(CurrentTrack);
		GotoTrack(CurrentTrack);
		EndPosition:=GetEndPosition(CurrentTrack);
		CDForm.CDPanel.Play;
	end;
	SetButtons(CDPlaying);
end;

procedure TCDForm.MMEjectClick(Sender: TObject);
var
  SetParm      : TMCI_SET_Parms;
begin
	if PlayerStatus=cdNotReady then
	begin
		try
			SetParm.dwCallback  := Handle;
			SetParm.dwAudio     := MCI_SET_AUDIO_ALL;
			mciSendCommand(CDPanel.DeviceID,
			   mci_SET,(mci_Notify or MCI_SET_DOOR_CLOSED),
			   Longint(@SetParm) );
		except
		end;
	end else
	begin
		PlayerStatus:=cdNotReady;
		DisablePlayer;
		CDForm.CDPanel.Eject;
		MMEject.Down:=False;
	end;
end;

procedure TCDForm.MMForwardMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
	MoveTimer.Interval:=500;
	MoveTimer.Enabled:=True;
	downcnt:=300;
	stepgap:=1000;
	Ticker.Enabled:=False;
	CDPanel.Pause;
end;

procedure TCDForm.MMForwardMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
	MoveTimer.Enabled:=False;
	if PlayerStatus=CDPlaying then CDForm.CDPanel.Resume;
	Ticker.Enabled:=True;
end;

procedure TCDForm.MoveTimerTimer(Sender: TObject);
var
	pos: longint;
begin
	pos:=CDPanel.Position;
	if downcnt>20 then
	begin
		downcnt:=downcnt-20;
		MoveTimer.Interval:=downcnt;
	end	else
	begin
		if (stepgap>0) and (stepgap<3000) then stepgap:=stepgap+1000
		else if (stepgap<0) and (stepgap>-3000) then stepgap:=stepgap-1000;
	end;
	pos:=pos+StepGap;
	if (stepgap<0) and (pos<=0) then
	begin
		pos:=0;
	end else if (stepgap>0) and (pos>=CurrentCD.CDLength) then
	begin
		pos:=CurrentCD.CDLength;
	end;
	CDPanel.Position:=pos;
	GetPositions;
	PositionDisplay;
end;

procedure TCDForm.MMRewindMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
	MoveTimer.Interval:=500;
	MoveTimer.Enabled:=True;
	downcnt:=300;
	stepgap:=-1000;
	Ticker.Enabled:=False;
	CDPanel.Pause;
end;

procedure TCDForm.MMRewindMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
	MoveTimer.Enabled:=False;
	if PlayerStatus=CDPlaying then CDForm.CDPanel.Resume;
	Ticker.Enabled:=True;
end;

end.
